// demo1.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#import ".\gsqlparser_ao.dll"  no_namespace
#include ".\debug\gsqlparser_ao.tlh"

void pp();

/// Caller Must SysFreeString on the BSTR out parm
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString);

/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzString,DWORD &buflen);

HRESULT HResultFromLastError(DWORD dwError = 0);


int _tmain(int argc, _TCHAR* argv[])
{
		if FAILED(CoInitialize(NULL))
	{
		CoUninitialize();
   	    printf("failed!\n");
		return -1;
	}
	pp();
	CoUninitialize();
	return 0;
}




void pp()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;
	ILzFmtOptPtr gFmtOpt;

    
    gFmtOpt.CreateInstance("gsqlparser_ao.LzFmtOpt");
	gFmtOpt->case_keywords = coLowercase; //coUppercase;
    gFmtOpt->Select_keywords_alignOption = aloLeft;//aloRight;
    gFmtOpt->case_keywords = coUppercase;
    gFmtOpt->case_funcname = coInitCap;
    gFmtOpt->case_identifier = coNoChange;
    gFmtOpt->AndOrUnderWhere = false;
    gFmtOpt->AlignAliasInSelectList = true;
	gFmtOpt->linenumber_enabled = false;
	gFmtOpt->HavingClauseInNewline = false;

	// more format option check document shipped together with this demo
    // or online document: http://www.dpriver.com/ppv3/index.php

	sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);
   	
	
    sprintf( buffer, "%s", "select a,b from c where a>1 group by a having count(*) > 10" );
	sqlparser->SqlText = buffer;
	
	sqlparser->PrettyPrint();
	
	// to html
	
	// sqlparser->ToHtml();

	// to rtf
	
	// sqlparser->ToRTF();

	BSTRToString( (wchar_t *)sqlparser->FormattedSqlText,&lpzStr,cbSize);
    printf(lpzStr);
    printf("\n");

	/// Must release allocated string 
    HeapFree(GetProcessHeap(),0,lpzStr);
	
    char str[10];
	scanf("%c", str);
 
}



/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzPassedString,DWORD &buflen) {

//buflen = SysStringLen((unsigned short *)vResult.pbstrVal);

char *lpzString = NULL;

__try {
	buflen = SysStringLen(bstrString);
	if (buflen == 0)  {
	   *lpzPassedString = NULL;
	   return 0;
	}

	lpzString = (char *) HeapAlloc (GetProcessHeap (), 0, buflen + 1); 
	if (!lpzString) 
	   return HResultFromLastError();


	/// ***  4th parm (Buflen) parameter must not be the default (-1) or NULLs will terminate the string
	if (0 == WideCharToMultiByte(CP_ACP, 0, bstrString, buflen, 
								 lpzString, buflen + 1, NULL, NULL)) {
	   buflen = 0;
	   *lpzPassedString = NULL;
	   return HResultFromLastError();
	}

	// null terminate string
	*(lpzString + buflen) = 0;  // This is not really necessary but

	*lpzPassedString = lpzString;
}
__except(EXCEPTION_EXECUTE_HANDLER) {
    __try { 
		if (lpzString)
			 HeapFree(GetProcessHeap(),0,lpzString);
	}
     __except(EXCEPTION_EXECUTE_HANDLER) {;}

	 *lpzPassedString = NULL;
	 buflen = 0;
     return -1;
}

return 0;
}

/// Caller must call SysFreeString() on bstr
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString) {

    OLECHAR *wzString = NULL;

__try {
    bstrString = NULL;

    if (cbSize == 0)  {
		if (!lpzString) {
			bstrString = NULL;
			return 0;
		}
		cbSize = strlen(lpzString);
	}

	wzString = (OLECHAR *) HeapAlloc (GetProcessHeap (), 0, cbSize * 2 + 2  );
	if (wzString == NULL) 
		return HResultFromLastError();

	if (0 == MultiByteToWideChar(CP_ACP, 0, (const char*)lpzString, cbSize, wzString, cbSize ) ) 
		return HResultFromLastError();

	bstrString = SysAllocStringLen(wzString,cbSize);
	if (NULL == bstrString) 
		return HResultFromLastError();

    /// Release the Wide character string
	__try {
		HeapFree(GetProcessHeap(),0,wzString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {
        return -1;
	}
}
__except(EXCEPTION_EXECUTE_HANDLER) {
	__try {
		if (wzString)
			HeapFree(GetProcessHeap(),0,wzString);
		if (bstrString)
			SysFreeString(bstrString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {;}

	bstrString = NULL;    
	return -1;
}

	return 0;
}


HRESULT HResultFromLastError(DWORD dwError)
{
    if (dwError == 0) 
	   dwError = GetLastError();

	return HRESULT_FROM_WIN32(dwError);
}


